/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_COMMON_COMMON_DEFINES_SOMEIP_STUB_ADAPTER_HPP_
#define V1_COMMONAPI_TELUX_COMMON_COMMON_DEFINES_SOMEIP_STUB_ADAPTER_HPP_

#include <v1/commonapi/telux/common/CommonDefinesStub.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace common {

template <typename _Stub = ::v1::commonapi::telux::common::CommonDefinesStub, typename... _Stubs>
class CommonDefinesSomeIPStubAdapterInternal
    : public virtual CommonDefinesStubAdapter,
      public CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...>,
      public std::enable_shared_from_this< CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> CommonDefinesSomeIPStubAdapterHelper;

    ~CommonDefinesSomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        CommonDefinesSomeIPStubAdapterHelper::deinit();
    }

    void deactivateManagedInstances() {}
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v1::commonapi::telux::common::CommonDefinesStub,
        CommonAPI::Version
    > getCommonDefinesInterfaceVersionStubDispatcher;

    CommonDefinesSomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
        CommonDefinesSomeIPStubAdapterHelper(
            _address,
            _connection,
            std::dynamic_pointer_cast< CommonDefinesStub>(_stub)),
        getCommonDefinesInterfaceVersionStubDispatcher(&CommonDefinesStub::lockInterfaceVersionAttribute, &CommonDefinesStub::getInterfaceVersion, false, true)
    {
        // Provided events/fields
    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};


template <typename _Stub, typename... _Stubs>
void CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v1::commonapi::telux::common::CommonDefinesStub, typename... _Stubs>
class CommonDefinesSomeIPStubAdapter
    : public CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    CommonDefinesSomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          CommonDefinesSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace common
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_COMMON_Common_Defines_SOMEIP_STUB_ADAPTER_HPP_
